# wxDynamicLibrary Class Reference
[Application and Process Management]

`#include <wx/dynlib.h>`

## Detailed Description

wxDynamicLibrary is a class representing dynamically loadable library (Windows DLL, shared library under Unix etc).

Just create an object of this class to load a library and don't worry about unloading it -- it will be done in the objects destructor automatically.

The following flags can be used with wxDynamicLibrary() or Load():

## Styles

This class supports the following styles:

- wxDL_LAZY:
  Equivalent of RTLD_LAZY under Unix, ignored elsewhere.
- wxDL_NOW:
  Equivalent of RTLD_NOW under Unix, ignored elsewhere.
- wxDL_GLOBAL:
  Equivalent of RTLD_GLOBAL under Unix, ignored elsewhere.
- wxDL_VERBATIM:
  Don't try to append the appropriate extension to the library name (this is done by default).
- wxDL_DEFAULT:
  Default flags, same as wxDL_NOW currently.
- wxDL_QUIET:
  Don't log an error message if the library couldn't be loaded.

##

Library: wxBase

Category: Application and Process Management

## Public Member Functions
| wxDynamicLibrary ()
| Default constructor.
| wxDynamicLibrary (const wxString &name, int flags=wxDL_DEFAULT)
| Constructor.
wxDllType | Detach ()
| Detaches this object from its library handle, i.e.
void * | GetSymbol (const wxString &name, bool *success=0) const
| Returns pointer to symbol name in the library or NULL if the library contains no such symbol.
void * | GetSymbolAorW (const wxString &name) const
| This function is available only under Windows as it is only useful when dynamically loading symbols from standard Windows DLLs.
bool | HasSymbol (const wxString &name) const
| Returns true if the symbol with the given name is present in the dynamic library, false otherwise.
bool | IsLoaded () const
| Returns true if the library was successfully loaded, false otherwise.
bool | Load (const wxString &name, int flags=wxDL_DEFAULT)
| Loads DLL with the given name into memory.
void | Unload ()
| Unloads the library from memory.
## Static Public Member Functions
static wxString | CanonicalizeName (const wxString &name, wxDynamicLibraryCategory cat=wxDL_LIBRARY)
| Returns the platform-specific full name for the library called name.
static wxString | CanonicalizePluginName (const wxString &name, wxPluginCategory cat=wxDL_PLUGIN_GUI)
| This function does the same thing as CanonicalizeName() but for wxWidgets plugins.
static wxDllType | GetProgramHandle ()
| Return a valid handle for the main program itself or NULL if symbols from the main program can't be loaded on this platform.
static wxDynamicLibraryDetailsArray | ListLoaded ()
| This static method returns a wxArray containing the details of all modules loaded into the address space of the current project.
static void | Unload (wxDllType handle)
| Unloads the library from memory.

List of all members.

## Constructor & Destructor Documentation

wxDynamicLibrary::wxDynamicLibrary | ( |  | ) |

Default constructor.

wxDynamicLibrary::wxDynamicLibrary | ( | const wxString & | name,
|  | int | flags = `wxDL_DEFAULT` |
| ) |  |  |

Constructor.

Calls Load() with the given name.

## Member Function Documentation

static wxString wxDynamicLibrary::CanonicalizeName | ( | const wxString & | name,
|  | wxDynamicLibraryCategory | cat = `wxDL_LIBRARY` |
| ) |  |  | `[static]`

Returns the platform-specific full name for the library called name.

E.g. it adds a `".dll"` extension under Windows and `"lib"` prefix and `".so"`, `".sl"` or `".dylib"` extension under Unix.

See also:
  CanonicalizePluginName()

static wxString wxDynamicLibrary::CanonicalizePluginName | ( | const wxString & | name,
|  | wxPluginCategory | cat = `wxDL_PLUGIN_GUI` |
| ) |  |  | `[static]`

This function does the same thing as CanonicalizeName() but for wxWidgets plugins.

The only difference is that compiler and version information are added to the name to ensure that the plugin which is going to be loaded will be compatible with the main program.

wxDllType wxDynamicLibrary::Detach | ( |  | ) |

Detaches this object from its library handle, i.e.

the object will not unload the library any longer in its destructor but it is now the callers responsibility to do this using Unload().

static wxDllType wxDynamicLibrary::GetProgramHandle | ( |  | ) | `[static]`

Return a valid handle for the main program itself or NULL if symbols from the main program can't be loaded on this platform.

void* wxDynamicLibrary::GetSymbol | ( | const wxString & | name,
|  | bool * | success = `0` |
| ) |  |  | const

Returns pointer to symbol name in the library or NULL if the library contains no such symbol.

See also:
  wxDYNLIB_FUNCTION()

void* wxDynamicLibrary::GetSymbolAorW | ( | const wxString & | name | ) | const

This function is available only under Windows as it is only useful when dynamically loading symbols from standard Windows DLLs.

Such functions have either `'A'` (in ANSI build) or `'W'` (in Unicode, or wide character build) suffix if they take string parameters. Using this function, you can use just the base name of the function and the correct suffix is appended automatically depending on the current build. Otherwise, this method is identical to GetSymbol().

Availability: only available for the wxMSW port.

bool wxDynamicLibrary::HasSymbol | ( | const wxString & | name | ) | const

Returns true if the symbol with the given name is present in the dynamic library, false otherwise.

Unlike GetSymbol(), this function doesn't log an error message if the symbol is not found.

Since:
  2.5.4

bool wxDynamicLibrary::IsLoaded | ( |  | ) | const

Returns true if the library was successfully loaded, false otherwise.

static wxDynamicLibraryDetailsArray wxDynamicLibrary::ListLoaded | ( |  | ) | `[static]`

This static method returns a wxArray containing the details of all modules loaded into the address space of the current project.

The array elements are objects of the type: wxDynamicLibraryDetails. The array will be empty if an error occurred.

This method is currently implemented only under Win32 and Linux and is useful mostly for diagnostics purposes.

bool wxDynamicLibrary::Load | ( | const wxString & | name,
|  | int | flags = `wxDL_DEFAULT` |
| ) |  |  |

Loads DLL with the given name into memory.

The flags argument can be a combination of the styles outlined in the class description.

Returns true if the library was successfully loaded, false otherwise.

static void wxDynamicLibrary::Unload | ( | wxDllType | handle | ) | `[static]`

Unloads the library from memory.

wxDynamicLibrary object automatically calls this method from its destructor if it had been successfully loaded.

This version of Unload() is only used if you need to keep the library in memory during a longer period of time than the scope of the wxDynamicLibrary object. In this case you may call Detach() and store the handle somewhere and call this static method later to unload it.

void wxDynamicLibrary::Unload | ( |  | ) |

Unloads the library from memory.

wxDynamicLibrary object automatically calls this method from its destructor if it had been successfully loaded.

|  | [ top ]